Index: branches/BNC_2.12/src/upload/bncrtnetuploadcaster.cpp
===================================================================
--- branches/BNC_2.12/src/upload/bncrtnetuploadcaster.cpp	(revision 8992)
+++ branches/BNC_2.12/src/upload/bncrtnetuploadcaster.cpp	(revision 9036)
@@ -2515,5 +740,5 @@
         || co.NumberOfSat[CLOCKORBIT_SATBDS] > 0) {
       char obuffer[CLOCKORBIT_BUFFERSIZE];
-      int len = MakeClockOrbit(&co, COTYPE_AUTO, 0, obuffer, sizeof(obuffer));
+      int len = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_AUTO, 0, obuffer, sizeof(obuffer));
       if (len > 0) {
         hlpBufferCo = QByteArray(obuffer, len);
@@ -2529,5 +754,5 @@
       if (fmod(epoTime.gpssec(), _samplRtcmEphCorr) == 0.0) {
         co.UpdateInterval = ephUpdInd;
-        int len1 = MakeClockOrbit(&co, COTYPE_GPSORBIT, 1, obuffer,
+        int len1 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_GPSORBIT, 1, obuffer,
             sizeof(obuffer));
         co.UpdateInterval = clkUpdInd;
@@ -2541,5 +766,5 @@
                   co.NumberOfSat[CLOCKORBIT_SATSBAS]    > 0 ||
                   co.NumberOfSat[CLOCKORBIT_SATBDS]     > 0   ) ? 1 : 0;
-      int len2 = MakeClockOrbit(&co, COTYPE_GPSCLOCK, mmsg, obuffer,
+      int len2 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_GPSCLOCK, mmsg, obuffer,
           sizeof(obuffer));
       if (len2 > 0) {
@@ -2551,5 +776,5 @@
       if (fmod(epoTime.gpssec(), _samplRtcmEphCorr) == 0.0) {
         co.UpdateInterval = ephUpdInd;
-        int len1 = MakeClockOrbit(&co, COTYPE_GLONASSORBIT, 1, obuffer,
+        int len1 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_GLONASSORBIT, 1, obuffer,
             sizeof(obuffer));
         co.UpdateInterval = clkUpdInd;
@@ -2562,5 +787,5 @@
                   co.NumberOfSat[CLOCKORBIT_SATSBAS]    > 0 ||
                   co.NumberOfSat[CLOCKORBIT_SATBDS]     > 0   ) ? 1 : 0;
-      int len2 = MakeClockOrbit(&co, COTYPE_GLONASSCLOCK, mmsg, obuffer,
+      int len2 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_GLONASSCLOCK, mmsg, obuffer,
           sizeof(obuffer));
       if (len2 > 0) {
@@ -2572,5 +797,5 @@
       if (fmod(epoTime.gpssec(), _samplRtcmEphCorr) == 0.0) {
         co.UpdateInterval = ephUpdInd;
-        int len1 = MakeClockOrbit(&co, COTYPE_GALILEOORBIT, 1, obuffer,
+        int len1 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_GALILEOORBIT, 1, obuffer,
             sizeof(obuffer));
         co.UpdateInterval = clkUpdInd;
@@ -2582,5 +807,5 @@
                   co.NumberOfSat[CLOCKORBIT_SATSBAS]    > 0 ||
                   co.NumberOfSat[CLOCKORBIT_SATBDS]     > 0   ) ? 1 : 0;
-      int len2 = MakeClockOrbit(&co, COTYPE_GALILEOCLOCK, mmsg, obuffer,
+      int len2 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_GALILEOCLOCK, mmsg, obuffer,
           sizeof(obuffer));
       if (len2 > 0) {
@@ -2592,5 +817,5 @@
       if (fmod(epoTime.gpssec(), _samplRtcmEphCorr) == 0.0) {
         co.UpdateInterval = ephUpdInd;
-        int len1 = MakeClockOrbit(&co, COTYPE_QZSSORBIT, 1, obuffer,
+        int len1 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_QZSSORBIT, 1, obuffer,
             sizeof(obuffer));
         co.UpdateInterval = clkUpdInd;
@@ -2601,5 +826,5 @@
       int mmsg = (co.NumberOfSat[CLOCKORBIT_SATSBAS]    > 0 ||
                   co.NumberOfSat[CLOCKORBIT_SATBDS]     > 0   ) ? 1 : 0;
-      int len2 = MakeClockOrbit(&co, COTYPE_QZSSCLOCK, mmsg, obuffer,
+      int len2 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_QZSSCLOCK, mmsg, obuffer,
           sizeof(obuffer));
       if (len2 > 0) {
@@ -2611,5 +836,5 @@
       if (fmod(epoTime.gpssec(), _samplRtcmEphCorr) == 0.0) {
         co.UpdateInterval = ephUpdInd;
-        int len1 = MakeClockOrbit(&co, COTYPE_SBASORBIT, 1, obuffer,
+        int len1 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_SBASORBIT, 1, obuffer,
             sizeof(obuffer));
         co.UpdateInterval = clkUpdInd;
@@ -2619,5 +844,5 @@
       }
       int mmsg = (co.NumberOfSat[CLOCKORBIT_SATBDS] > 0) ? 1 : 0;
-      int len2 = MakeClockOrbit(&co, COTYPE_SBASCLOCK, mmsg, obuffer,
+      int len2 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_SBASCLOCK, mmsg, obuffer,
           sizeof(obuffer));
       if (len2 > 0) {
@@ -2629,5 +854,5 @@
       if (fmod(epoTime.gpssec(), _samplRtcmEphCorr) == 0.0) {
         co.UpdateInterval = ephUpdInd;
-        int len1 = MakeClockOrbit(&co, COTYPE_BDSORBIT, 1, obuffer,
+        int len1 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_BDSORBIT, 1, obuffer,
             sizeof(obuffer));
         co.UpdateInterval = clkUpdInd;
@@ -2637,5 +862,5 @@
       }
       int mmsg = 0;
-      int len2 = MakeClockOrbit(&co, COTYPE_BDSCLOCK, mmsg, obuffer,
+      int len2 = _ssrCorr->MakeClockOrbit(&co, _ssrCorr->COTYPE_BDSCLOCK, mmsg, obuffer,
           sizeof(obuffer));
       if (len2 > 0) {
@@ -2655,5 +880,5 @@
       || bias.NumberOfSat[CLOCKORBIT_SATBDS] > 0) {
     char obuffer[CLOCKORBIT_BUFFERSIZE];
-    int len = MakeCodeBias(&bias, CBTYPE_AUTO, 0, obuffer, sizeof(obuffer));
+    int len = _ssrCorr->MakeCodeBias(&bias, _ssrCorr->CBTYPE_AUTO, 0, obuffer, sizeof(obuffer));
     if (len > 0) {
       hlpBufferBias = QByteArray(obuffer, len);
@@ -2671,5 +896,5 @@
       || phasebias.NumberOfSat[CLOCKORBIT_SATBDS] > 0) {
     char obuffer[CLOCKORBIT_BUFFERSIZE];
-    int len = MakePhaseBias(&phasebias, PBTYPE_AUTO, 0, obuffer,
+    int len = _ssrCorr->MakePhaseBias(&phasebias, _ssrCorr->PBTYPE_AUTO, 0, obuffer,
         sizeof(obuffer));
     if (len > 0) {
@@ -2683,5 +908,5 @@
   if (vtec.NumLayers > 0) {
     char obuffer[CLOCKORBIT_BUFFERSIZE];
-    int len = MakeVTEC(&vtec, 0, obuffer, sizeof(obuffer));
+    int len = _ssrCorr->MakeVTEC(&vtec, 0, obuffer, sizeof(obuffer));
     if (len > 0) {
       hlpBufferVtec = QByteArray(obuffer, len);
@@ -2699,5 +924,5 @@
     double rtnUra, const ColumnVector& rtnClk, const ColumnVector& rtnVel,
     const ColumnVector& rtnCoM, const ColumnVector& rtnClkSig,
-    struct ClockOrbit::SatData* sd, QString& outLine) {
+    struct SsrCorr::ClockOrbit::SatData* sd, QString& outLine) {
 
   // Broadcast Position and Velocity
Index: branches/BNC_2.12/src/upload/bncrtnetuploadcaster.h
===================================================================
--- branches/BNC_2.12/src/upload/bncrtnetuploadcaster.h	(revision 8992)
+++ branches/BNC_2.12/src/upload/bncrtnetuploadcaster.h	(revision 9036)
@@ -6,11 +6,6 @@
 #include "bnctime.h"
 #include "ephemeris.h"
-extern "C" {
-#ifdef USE_SSR_RTCM
 #include "../RTCM3/clock_and_orbit/clock_orbit_rtcm.h"
-#elif  USE_SSR_IGS
 #include "../RTCM3/clock_and_orbit/clock_orbit_igs.h"
-#endif
-}
 
 class bncEphUser;
@@ -25,5 +20,6 @@
                   const QString& outHost, int outPort,
                   const QString& password,
-                  const QString& crdTrafo, bool  CoM,
+                  const QString& crdTrafo, const QString& ssrFormat,
+                  bool  CoM,
                   const QString& sp3FileName,
                   const QString& rnxFileName,
@@ -41,5 +37,5 @@
                         const ColumnVector& rtnCoM,
                         const ColumnVector& rtnClkSig,
-                        struct ClockOrbit::SatData* sd,
+                        struct SsrCorr::ClockOrbit::SatData* sd,
                         QString& outLine);
   void crdTrafo(int GPSWeek, ColumnVector& xyz, double& dc);
@@ -51,4 +47,6 @@
   QString        _rtnetStreamBuffer;
   QString        _crdTrafo;
+  SsrCorr*       _ssrCorr;
+  QString        _ssrFormat;
   bool           _CoM;
   int            _PID;
